{{
 DemonrfNRF24L01. Demonstrates the driver for nRF24L01+ and the SPIdriver. Includes a carrier wave scanner and a simple Sender, Receiver, and Beacon demo.
 Erlend Fj. 2015
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------

 Includes Enhanced Shockburst Mode which provides a link level transport protocol

-----------------------------------------------------------------------------------------------------------------------------------------------------------------------
}}
{
 Acknowledgements:  

=======================================================================================================================================================================

 About nRF24L01+
 ---------------
  -see driver heading

 
 REF:


=======================================================================================================================================================================
}
 
CON

          _clkmode = xtal1 + pll16x
          _xinfreq = 5_000_000                                      'use 5MHz crystal
        
          clk_freq = (_clkmode >> 6) * _xinfreq                     'system freq as a constant
          mSec     = clk_freq / 1_000                               'ticks in 1ms
          uSec     = clk_freq / 1_000_000                                   'ticks in 1us     (80 ticks)
  
          PINmosi  = 5     
          PINmiso  = 6     
          PINclk   = 7     
          PINcs    = 0     
          PINce    = 1     

          channel  = 7    '113                  

VAR
      BYTE  telegram[32]
                                         
DAT
      RFaddr  BYTE  $E7, $E7, $E7, $E7, $E7                           'address used for transmitter&receiver id
      hello   BYTE "Hello world, this is a tx test!"               '31 + 1 zero byte string - only used by the Beacon method
                                                  
OBJ
      nrf  : "NRF24L01pDriver"
      pst    : "Parallax Serial Terminal"
                                               
PUB Main | value
                                
  pst.start(115200)
  
  pst.Str(String("Initializing transmitter..."))
  nrf.Init(PINmosi, PINmiso, PINclk, PINcs, PINce)
  pst.Str(String("done."))
  pst.Chars(pst#NL, 2)

  transmitter

PUB Transmitter  | Bin_Count

   pst.Str(String("Sends a string of up to 32 characters to a receiver on same channel and address"))
   pst.Chars(pst#NL, 2)

   nrf.SetPrimaryMode(0)                   'primary transmitter
   nrf.EnableRXpipes(%00001)               'pipe0 enabled
   nrf.SetShockburst(1)                    'fancy transport protocol                              
   nrf.SetPayloadWidth(0, 32)              'set up pipe0 for max length (32 bytes) 
   nrf.SetTransmitterPower(0)              'set to max power: 0dB
   nrf.SetRadioDatarate(1)                 'set to max datarate: 2Mbps
   nrf.SetRFchannel(channel)
   nrf.WriteRxPipeAddress(@RFaddr, 0)      'set pipe0 rf addr/id equal to DAT variable (assuming default address width of 5 bytes)
   nrf.WriteTxPipeAddress(@RFaddr)         'd.o. for tx
   nrf.FLUSH_TX                            'empty the buffer
   
   Bin_Count := 1
   
   REPEAT
     pst.Chars(pst#NL, 2)
     telegram := Bin_Count
     nrf.W_TX_PAYLOAD(Bin_Count, 1)
     Bin_Count++  
     if Bin_Count > 255
       Bin_Count~      
     waitcnt((clkfreq/3) + cnt) 
  
     nrf.ReadNclearInterrupts              'get rid of old interrupts
     nrf.W_TX_PAYLOAD(@telegram, 32)       'write the string into tx buffer  ' 
     pst.Bin(telegram, 8)
     
     nrf.ChipEnable(1)                     'pulse the radio to transmit
     WAITCNT(mSec + CNT)
     nrf.ChipEnable(0)
     WAITCNT(mSec + CNT)
     
     IF nrf.IsDataSent                  'does not return======= 
       pst.Chars(pst#NL, 2)
       pst.Str(String("Data sent. "))
       pst.Chars(pst#NL, 2)
     IF nrf.IsMaxRetries                'does not return========= 
       pst.Chars(pst#NL, 2)  
       pst.Str(String("Max retries "))  
       pst.Chars(pst#NL, 2)
     IF nrf.IsFullTX                    'does not return======== 
       pst.Chars(pst#NL, 2)  
       pst.Str(String("TX buffer full "))  
       pst.Chars(pst#NL, 2)
       
     pst.Chars(pst#NL, 1)  
     pst.Str(String("Conditional statements not executed "))
     pst.Chars(pst#NL, 2)  
      
     IF STRSIZE(@telegram)== 0
       nrf.FLUSH_TX                            'empty the buffer
       nrf.ReadNclearInterrupts                'get rid of old interrupts
       QUIT
     

PRI private_method_name


DAT
name    byte  "string_data",0        
        